---
title: Review Quiz Results
product: Form Library
description: Learn how to display test or quiz results to a participant for review and indicate correct and incorrect answers with labels. Enable read-only mode to avoid any accidental chances in submitted data. Explore our ready-to-use JavaScript form library demo.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Review Quiz Results (Vanilla JS)

Tests and quizzes enable participants to assess their level of knowledge on a particular subject. After completing a test or quiz, participants can review and analyze their results. This demo demonstrates how to configure the quiz review mode.

## Display a User Response

User responses are stored as JSON objects in which keys are question names and values are user answers. Obtain a JSON object with the response you want to display and assign it to the survey's [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) property.

## Indicate Correct and Incorrect Answers

There are many ways to indicate correct and incorrect answers in a quiz: colorize question titles or question boxes, add indicator icons (for example, green tick for correct and red cross for incorrect answers), display error messages next to incorrect answers, and so forth. This demo shows how to mark correct and incorrect answers using textual labels with different colors. The labels are added to question titles.

To implement the indication, check whether a question was answered correctly by calling its [`isAnswerCorrect()`](https://surveyjs.io/form-library/documentation/api-reference/question#isAnswerCorrect) method. Depending on the check result, add the "Correct" or "Incorrect" label to the question title (see the `changeTitle` function in code). A review form implies that the quiz has already been passed, and you need to assign the labels before rendering the form. To do this, iterate over all quiz questions and call the `changeTitle` function for them.

To stylize the labels, handle the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onTextMarkdown) event. This event allows you to modify the HTML markup of rendered texts. Within the event handler, you need to identify text strings that contain either the "Correct" or "Incorrect" substring. Wrap these substrings in a `<span>` element with an applied CSS class to customize the text appearance (see the `getTextHtml` function in code).

## Switch the Form to Read-Only Mode

When users review quiz results, they shouldn't be able to edit them to maintain data integrity. Read-only mode helps ensure that the results remain unchanged. To enable this mode, assign `true` to the survey's [`readOnly`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#readOnly) property before rendering the quiz on a page.

## Display All Questions on a Single Page

When creating a quiz, especially a timed one, you'll likely distribute questions across multiple form pages. However, for reviewing purposes, it's advantageous to consolidate all questions onto one page for a more compact presentation. To enable the single-page view, set the survey's [`questionsOnPageMode`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"singlePage"`. Additionally, hide the progress bar (if your quiz displays it) since a single-page quiz doesn't have other pages to switch to. Set the [`showProgressBar`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showProgressBar) property to `false`.

## Save Quiz Results to PDF

If you want to allow your users to print quiz results or share them with others, export the results to a PDF form using SurveyJS PDF Generator. This component is an add-on to SurveyJS Form Library that enables users to generate PDF documents from online forms, surveys, and quizzes. Refer to the following help topics for information on how to get started with SurveyJS PDF Generator in different JavaScript frameworks:

[Export Survey to PDF in an Angular Application](https://surveyjs.io/pdf-generator/documentation/get-started-angular (linkStyle))
[Export Survey to PDF in a Vue.js Application](https://surveyjs.io/pdf-generator/documentation/get-started-vue (linkStyle))
[Export Survey to PDF in a React Application](https://surveyjs.io/pdf-generator/documentation/get-started-react (linkStyle))
[Export Survey to PDF in an HTML/CSS/JavaScript Application](https://surveyjs.io/pdf-generator/documentation/get-started-html-css-javascript (linkStyle))

The following demo shows how to indicate correct and incorrect answers in a generated PDF form:

[Change Question Title Colors in PDF](/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
.correctAnswer {
    color: #00613D;
    text-transform: uppercase;
}
.incorrectAnswer {
    color: #9C0227;
    text-transform: uppercase;
}

```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.data = {
    civilwar: "1861-1865",
    libertyordeath: "Samuel Adams",
    magnacarta: "The foundation of the British parliamentary system"
};

survey.readOnly = true;
survey.questionsOnPageMode = "singlePage";
survey.showProgressBar = false;

const correctStr = "Correct";
const incorrectStr = "Incorrect";

// Builds an HTML string to display in a question title
function getTextHtml (text, str, isCorrect) {
    if (text.indexOf(str) < 0)
        return undefined;

    return text.substring(0, text.indexOf(str)) +
        "<span class='" +  (isCorrect ? "correctAnswer" : "incorrectAnswer" ) + "'>" +
            str +
        "</span>";
}

// Adds "Correct" or "Incorrect" to a question title
function changeTitle (q) {
    if (!q) return;

    const isCorrect = q.isAnswerCorrect();
    if (!q.prevTitle) {
        q.prevTitle = q.title;
    }
    if (isCorrect === undefined) {
        q.title = q.prevTitle;
    }
    q.title =  q.prevTitle + ' ' + (isCorrect ? correctStr : incorrectStr);
}

// Uncomment the following lines if you allow respondents to edit their answers
// and want to display whether an answer is correct or not immediately after it has been given
// survey.onValueChanged.add((_, options) => {
//     changeTitle(options.question);
// });

survey.onTextMarkdown.add((_, options) => {
    const text = options.text;
    let html = getTextHtml(text, correctStr, true);
    if (!html) {
        html = getTextHtml(text, incorrectStr, false);
    }
    if (!!html) {
        // Set an HTML string with the "Correct" or "Incorrect" suffix for display
        options.html = html;
    }
});

// Indicate correct and incorrect answers at startup
survey.getAllQuestions().forEach(question => changeTitle(question));

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "American History",
  "showProgressBar": true,
  "progressBarLocation": "bottom",
  "showTimer": true,
  "timeLimitPerPage": 10,
  "timeLimit": 25,
  "firstPageIsStartPage": true,
  "startSurveyText": "Start Quiz",
  "pages": [
    {
      "elements": [
        {
          "type": "html",
          "html": "You are about to start a quiz on American history. <br>You will have 10 seconds for every question and 25 seconds to end the quiz.<br>Enter your name below and click <b>Start Quiz</b> to begin."
        },
        {
          "type": "text",
          "name": "username",
          "titleLocation": "hidden",
          "isRequired": true
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system"
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/angular.md)
- [React](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/jquery.md)


---
title: Review Quiz Results
product: Form Library
description: Learn how to display test or quiz results to a participant for review and indicate correct and incorrect answers with labels. Enable read-only mode to avoid any accidental chances in submitted data. Explore our ready-to-use JavaScript form library demo.
framework: Angular
source: https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Review Quiz Results (Angular)

Tests and quizzes enable participants to assess their level of knowledge on a particular subject. After completing a test or quiz, participants can review and analyze their results. This demo demonstrates how to configure the quiz review mode.

## Display a User Response

User responses are stored as JSON objects in which keys are question names and values are user answers. Obtain a JSON object with the response you want to display and assign it to the survey's [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) property.

## Indicate Correct and Incorrect Answers

There are many ways to indicate correct and incorrect answers in a quiz: colorize question titles or question boxes, add indicator icons (for example, green tick for correct and red cross for incorrect answers), display error messages next to incorrect answers, and so forth. This demo shows how to mark correct and incorrect answers using textual labels with different colors. The labels are added to question titles.

To implement the indication, check whether a question was answered correctly by calling its [`isAnswerCorrect()`](https://surveyjs.io/form-library/documentation/api-reference/question#isAnswerCorrect) method. Depending on the check result, add the "Correct" or "Incorrect" label to the question title (see the `changeTitle` function in code). A review form implies that the quiz has already been passed, and you need to assign the labels before rendering the form. To do this, iterate over all quiz questions and call the `changeTitle` function for them.

To stylize the labels, handle the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onTextMarkdown) event. This event allows you to modify the HTML markup of rendered texts. Within the event handler, you need to identify text strings that contain either the "Correct" or "Incorrect" substring. Wrap these substrings in a `<span>` element with an applied CSS class to customize the text appearance (see the `getTextHtml` function in code).

## Switch the Form to Read-Only Mode

When users review quiz results, they shouldn't be able to edit them to maintain data integrity. Read-only mode helps ensure that the results remain unchanged. To enable this mode, assign `true` to the survey's [`readOnly`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#readOnly) property before rendering the quiz on a page.

## Display All Questions on a Single Page

When creating a quiz, especially a timed one, you'll likely distribute questions across multiple form pages. However, for reviewing purposes, it's advantageous to consolidate all questions onto one page for a more compact presentation. To enable the single-page view, set the survey's [`questionsOnPageMode`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"singlePage"`. Additionally, hide the progress bar (if your quiz displays it) since a single-page quiz doesn't have other pages to switch to. Set the [`showProgressBar`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showProgressBar) property to `false`.

## Save Quiz Results to PDF

If you want to allow your users to print quiz results or share them with others, export the results to a PDF form using SurveyJS PDF Generator. This component is an add-on to SurveyJS Form Library that enables users to generate PDF documents from online forms, surveys, and quizzes. Refer to the following help topics for information on how to get started with SurveyJS PDF Generator in different JavaScript frameworks:

[Export Survey to PDF in an Angular Application](https://surveyjs.io/pdf-generator/documentation/get-started-angular (linkStyle))
[Export Survey to PDF in a Vue.js Application](https://surveyjs.io/pdf-generator/documentation/get-started-vue (linkStyle))
[Export Survey to PDF in a React Application](https://surveyjs.io/pdf-generator/documentation/get-started-react (linkStyle))
[Export Survey to PDF in an HTML/CSS/JavaScript Application](https://surveyjs.io/pdf-generator/documentation/get-started-html-css-javascript (linkStyle))

The following demo shows how to indicate correct and incorrect answers in a generated PDF form:

[Change Question Title Colors in PDF](/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/ (linkStyle))

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "American History",
  "showProgressBar": true,
  "progressBarLocation": "bottom",
  "showTimer": true,
  "timeLimitPerPage": 10,
  "timeLimit": 25,
  "firstPageIsStartPage": true,
  "startSurveyText": "Start Quiz",
  "pages": [
    {
      "elements": [
        {
          "type": "html",
          "html": "You are about to start a quiz on American history. <br>You will have 10 seconds for every question and 25 seconds to end the quiz.<br>Enter your name below and click <b>Start Quiz</b> to begin."
        },
        {
          "type": "text",
          "name": "username",
          "titleLocation": "hidden",
          "isRequired": true
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system"
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
.correctAnswer {
    color: #00613D;
    text-transform: uppercase;
}
.incorrectAnswer {
    color: #9C0227;
    text-transform: uppercase;
}
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.data = {
            civilwar: "1861-1865",
            libertyordeath: "Samuel Adams",
            magnacarta: "The foundation of the British parliamentary system"
        };
        
        survey.readOnly = true;
        survey.questionsOnPageMode = "singlePage";
        survey.showProgressBar = false;
        
        const correctStr = "Correct";
        const incorrectStr = "Incorrect";
        
        // Builds an HTML string to display in a question title
        function getTextHtml (text, str, isCorrect) {
            if (text.indexOf(str) < 0)
                return undefined;
        
            return text.substring(0, text.indexOf(str)) +
                "<span class='" +  (isCorrect ? "correctAnswer" : "incorrectAnswer" ) + "'>" +
                    str +
                "</span>";
        }
        
        // Adds "Correct" or "Incorrect" to a question title
        function changeTitle (q) {
            if (!q) return;
        
            const isCorrect = q.isAnswerCorrect();
            if (!q.prevTitle) {
                q.prevTitle = q.title;
            }
            if (isCorrect === undefined) {
                q.title = q.prevTitle;
            }
            q.title =  q.prevTitle + ' ' + (isCorrect ? correctStr : incorrectStr);
        }
        
        // Uncomment the following lines if you allow respondents to edit their answers
        // and want to display whether an answer is correct or not immediately after it has been given
        // survey.onValueChanged.add((_, options) => {
        //     changeTitle(options.question);
        // });
        
        survey.onTextMarkdown.add((_, options) => {
            const text = options.text;
            let html = getTextHtml(text, correctStr, true);
            if (!html) {
                html = getTextHtml(text, incorrectStr, false);
            }
            if (!!html) {
                // Set an HTML string with the "Correct" or "Incorrect" suffix for display
                options.html = html;
            }
        });
        
        // Indicate correct and incorrect answers at startup
        survey.getAllQuestions().forEach(question => changeTitle(question));
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.correctAnswer {
    color: #00613D;
    text-transform: uppercase;
}
.incorrectAnswer {
    color: #9C0227;
    text-transform: uppercase;
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vanillajs.md)


---
title: Review Quiz Results
product: Form Library
description: Learn how to display test or quiz results to a participant for review and indicate correct and incorrect answers with labels. Enable read-only mode to avoid any accidental chances in submitted data. Explore our ready-to-use JavaScript form library demo.
framework: React
source: https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Review Quiz Results (React)

Tests and quizzes enable participants to assess their level of knowledge on a particular subject. After completing a test or quiz, participants can review and analyze their results. This demo demonstrates how to configure the quiz review mode.

## Display a User Response

User responses are stored as JSON objects in which keys are question names and values are user answers. Obtain a JSON object with the response you want to display and assign it to the survey's [`data`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#data) property.

## Indicate Correct and Incorrect Answers

There are many ways to indicate correct and incorrect answers in a quiz: colorize question titles or question boxes, add indicator icons (for example, green tick for correct and red cross for incorrect answers), display error messages next to incorrect answers, and so forth. This demo shows how to mark correct and incorrect answers using textual labels with different colors. The labels are added to question titles.

To implement the indication, check whether a question was answered correctly by calling its [`isAnswerCorrect()`](https://surveyjs.io/form-library/documentation/api-reference/question#isAnswerCorrect) method. Depending on the check result, add the "Correct" or "Incorrect" label to the question title (see the `changeTitle` function in code). A review form implies that the quiz has already been passed, and you need to assign the labels before rendering the form. To do this, iterate over all quiz questions and call the `changeTitle` function for them.

To stylize the labels, handle the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onTextMarkdown) event. This event allows you to modify the HTML markup of rendered texts. Within the event handler, you need to identify text strings that contain either the "Correct" or "Incorrect" substring. Wrap these substrings in a `<span>` element with an applied CSS class to customize the text appearance (see the `getTextHtml` function in code).

## Switch the Form to Read-Only Mode

When users review quiz results, they shouldn't be able to edit them to maintain data integrity. Read-only mode helps ensure that the results remain unchanged. To enable this mode, assign `true` to the survey's [`readOnly`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#readOnly) property before rendering the quiz on a page.

## Display All Questions on a Single Page

When creating a quiz, especially a timed one, you'll likely distribute questions across multiple form pages. However, for reviewing purposes, it's advantageous to consolidate all questions onto one page for a more compact presentation. To enable the single-page view, set the survey's [`questionsOnPageMode`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#questionsOnPageMode) property to `"singlePage"`. Additionally, hide the progress bar (if your quiz displays it) since a single-page quiz doesn't have other pages to switch to. Set the [`showProgressBar`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showProgressBar) property to `false`.

## Save Quiz Results to PDF

If you want to allow your users to print quiz results or share them with others, export the results to a PDF form using SurveyJS PDF Generator. This component is an add-on to SurveyJS Form Library that enables users to generate PDF documents from online forms, surveys, and quizzes. Refer to the following help topics for information on how to get started with SurveyJS PDF Generator in different JavaScript frameworks:

[Export Survey to PDF in an Angular Application](https://surveyjs.io/pdf-generator/documentation/get-started-angular (linkStyle))
[Export Survey to PDF in a Vue.js Application](https://surveyjs.io/pdf-generator/documentation/get-started-vue (linkStyle))
[Export Survey to PDF in a React Application](https://surveyjs.io/pdf-generator/documentation/get-started-react (linkStyle))
[Export Survey to PDF in an HTML/CSS/JavaScript Application](https://surveyjs.io/pdf-generator/documentation/get-started-html-css-javascript (linkStyle))

The following demo shows how to indicate correct and incorrect answers in a generated PDF form:

[Change Question Title Colors in PDF](/pdf-generator/examples/how-to-customize-question-title-colors-in-pdf-form/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.data = {
        civilwar: "1861-1865",
        libertyordeath: "Samuel Adams",
        magnacarta: "The foundation of the British parliamentary system"
    };
    
    survey.readOnly = true;
    survey.questionsOnPageMode = "singlePage";
    survey.showProgressBar = false;
    
    const correctStr = "Correct";
    const incorrectStr = "Incorrect";
    
    // Builds an HTML string to display in a question title
    function getTextHtml (text, str, isCorrect) {
        if (text.indexOf(str) < 0)
            return undefined;
    
        return text.substring(0, text.indexOf(str)) +
            "<span class='" +  (isCorrect ? "correctAnswer" : "incorrectAnswer" ) + "'>" +
                str +
            "</span>";
    }
    
    // Adds "Correct" or "Incorrect" to a question title
    function changeTitle (q) {
        if (!q) return;
    
        const isCorrect = q.isAnswerCorrect();
        if (!q.prevTitle) {
            q.prevTitle = q.title;
        }
        if (isCorrect === undefined) {
            q.title = q.prevTitle;
        }
        q.title =  q.prevTitle + ' ' + (isCorrect ? correctStr : incorrectStr);
    }
    
    // Uncomment the following lines if you allow respondents to edit their answers
    // and want to display whether an answer is correct or not immediately after it has been given
    // survey.onValueChanged.add((_, options) => {
    //     changeTitle(options.question);
    // });
    
    survey.onTextMarkdown.add((_, options) => {
        const text = options.text;
        let html = getTextHtml(text, correctStr, true);
        if (!html) {
            html = getTextHtml(text, incorrectStr, false);
        }
        if (!!html) {
            // Set an HTML string with the "Correct" or "Incorrect" suffix for display
            options.html = html;
        }
    });
    
    // Indicate correct and incorrect answers at startup
    survey.getAllQuestions().forEach(question => changeTitle(question));
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
.correctAnswer {
    color: #00613D;
    text-transform: uppercase;
}
.incorrectAnswer {
    color: #9C0227;
    text-transform: uppercase;
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "American History",
  "showProgressBar": true,
  "progressBarLocation": "bottom",
  "showTimer": true,
  "timeLimitPerPage": 10,
  "timeLimit": 25,
  "firstPageIsStartPage": true,
  "startSurveyText": "Start Quiz",
  "pages": [
    {
      "elements": [
        {
          "type": "html",
          "html": "You are about to start a quiz on American history. <br>You will have 10 seconds for every question and 25 seconds to end the quiz.<br>Enter your name below and click <b>Start Quiz</b> to begin."
        },
        {
          "type": "text",
          "name": "username",
          "titleLocation": "hidden",
          "isRequired": true
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "civilwar",
          "title": "When was the American Civil War?",
          "choices": [
            "1796-1803",
            "1810-1814",
            "1861-1865",
            "1939-1945"
          ],
          "correctAnswer": "1861-1865"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "libertyordeath",
          "title": "Whose quote is this: \"Give me liberty, or give me death\"?",
          "choicesOrder": "random",
          "choices": [
            "John Hancock",
            "James Madison",
            "Patrick Henry",
            "Samuel Adams"
          ],
          "correctAnswer": "Patrick Henry"
        }
      ]
    },
    {
      "elements": [
        {
          "type": "radiogroup",
          "name": "magnacarta",
          "title": "What is Magna Carta?",
          "choicesOrder": "random",
          "choices": [
            "The foundation of the British parliamentary system",
            "The Great Seal of the monarchs of England",
            "The French Declaration of the Rights of Man",
            "The charter signed by the Pilgrims on the Mayflower"
          ],
          "correctAnswer": "The foundation of the British parliamentary system"
        }
      ]
    }
  ],
  "completedHtml": "<h4>You got <b>{correctAnswers}</b> out of <b>{questionCount}</b> correct answers.</h4>",
  "completedHtmlOnCondition": [
    {
      "expression": "{correctAnswers} == 0",
      "html": "<h4>Unfortunately, none of your answers is correct. Please try again.</h4>"
    },
    {
      "expression": "{correctAnswers} == {questionCount}",
      "html": "<h4>Congratulations! You answered all the questions correctly!</h4>"
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/review-mode-for-quiz-results/vanillajs.md)
